// Autorun
$(function(){ 
      $('form').submit( function() {
        if ( $(this).data('blocked') == true) {
           return false;
        }   else {
          showBlackoutScreen();
        }
      });

      $('.blackout').click( function() {
        showBlackoutScreen();
            return true;
      });     

      $('input[name=page_title]').textcounter({ min: 20, max: 75});
      /*$('input[name=page_title]').css('min-width', '400px');*/
      $('input[name=page_description], textarea[name=page_description]').textcounter({ min: 100, max: 250});
      $('input[name=mini_desc], textarea[name=mini_desc]').textcounter({ min: 200, max: 512});

      $('body').on('click', '.fancybox-content a[data-fancybox]', function() {
              $.fancybox.close();
      })


      // Механизм фоновой отправки формы
      $('body').on('submit', '.fancybox-content form[data-autoajaxsubmit!=false]', function(e) {

          if ( $(this).data('blocked') == true) {
              return false;
          }


          var el = $(this);
          el.append('<input type="hidden" name="ajaxsubmit" value="true"/>');

          var fancyContent = $(el).closest('.fancybox-content');
          fancyContent.html('<div class="p-4 text-center"><div class="spinner-grow text-success"></div></div>');


          e.preventDefault();
          el.ajaxSubmit( function( data ) {
              // Если ответ в формате json
              try {
                var result = JSON.parse(data); 
                $.fancybox.close();
                if ( result.html ) {
                  $.fancybox.open( result.html );
                  if ( result.reload ) {
                    setTimeout("location.reload();", 2000);
                  }
                  if ( result.redirect ) {
                    setTimeout("location.href='" + result.redirect + "'" , 2000);
                  }
                } else {
                  if ( result.reload ) {
                    location.reload();
                  }
                }
              } catch(e) {
                $.fancybox.close();
                $.fancybox.open( data );
              }
          } );
          return false; 
      });

      $('body').on('submit', '.fancybox-content form[data-autoajaxsubmit=false]', function(e) {
          if ( $(this).data('blocked') == true) {
              return false;
          }

          $.fancybox.close();
          return true;
      });

      $('body').on('change', '[type=file]', function(e) {


        var label;
        if ($(this).parent().prop('nodeName') == 'LABEL') {
          label = $(this).parent();
        }  else {
           var id = $(this).attr('id');
           if (id != undefined) {
              var label = $('label[for='+id+']');
           }
        }

        if ( label != undefined ) {
           if ( $(this).get(0).files[0] != undefined ) {
             label.addClass('upload-file-filled');
           } else {
             label.removeClass('upload-file-filled');
           }
        }

      });


      // +/- assistent
      $('.input-group .btn-minus').on('click', function() {
          var el = $(this).closest('.input-group').find('input');

          var min = 0;
          if (el.attr('min')) min = el.attr('min');

          var value = el.val();

          if (value > min) {
              value--;
              el.val(value);
              el.change();
          }

          return true;
      });

      $('.input-group .btn-plus').on('click', function() {
          var el = $(this).closest('.input-group').find('input');

          var value = el.val();

          if (el.attr('max') != undefined && value >=  el.attr('max') ) return false;

          value++;
          el.val(value);
          el.change();          

          return true;
      });

});



var blackOutMessages  = [ 
        'Придумаваю новую отмазку, лишь бы не работать...', 
        'Майню биткойны...', 'Обучаю нейросеть убивать человеков...',
        'Гоняюсь за вирусами по жесткому диску...',
        'Рассчитываю фазы луны...',
        'Гоняю человеков в Quake II...',
        'Жду подходящего момента, чтобы показать ошибку...',
        'Бегу на склад сверить наличие...',
        'Компилирую...','Декомпилирую...','Загружаю...','Выгружаю...','Перезагружаю сервер...',
        'Подбираю коды запука ракет...'];
var blackOutMessagesIndex = 0;

function showBlackoutScreen() {
      $('#blackout_sbmt').css('display', 'flex');

      function random(n) {
        return Math.floor(Math.random() * Math.floor(n));
      }

      function shuffle (arr) {
        for (var i = 0; i < arr.length; i++) {
          var j = random(arr.length);
          var k = random(arr.length);
          var t = arr[j];
          arr[j] = arr[k];
          arr[k] = t;
        }
        return arr;
      }

      shuffle(blackOutMessages);

      setInterval(changeBlackoutText, 3000);
}

function changeBlackoutText() {
    $('#blackoutText').fadeOut('slow', function(){ 
      if ( blackOutMessagesIndex >= blackOutMessages.length ) {
        blackOutMessagesIndex = 0;
      } else {
        blackOutMessagesIndex++;
      }
      $('#blackoutText').html(blackOutMessages[blackOutMessagesIndex]);
      $('#blackoutText').fadeIn('slow');
    });
}

function submenuResize() {
  if ( window.innerWidth > 991 ) {
      $('.autosize-menu').each( function( i, el ) {
          var cnt = $(el).find('a').length;
          var width = $(el).width()  / cnt;
          $(el).find('a').css('max-width', width + 'px');
      });
  }
}


